> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/extension-dev/component_services.md).

# Component and Services

Component and Services developement

Component and Service developement is done by making an Angular project where you write your component or service in typescript

On github there is a [NG1 to TiNG example](https://github.com/Servoy/servoyworld_component/tree/ting) that has a "master" branch that just has the NG1 example and the "ting" branch has the TiNG example with some documentation what is what and how to convert.

The specification what a component or service has (properties that can be set, api's that can be called, or events (handlers) that a component can trigger) are defined in a [spec](/reference/extension-dev/component_services/spec-file.md)

What types can be used for the properties on the model of the component or service are described [here](/reference/extension-dev/component_services/spec-file/property_types.md), those properties can have [tags](/reference/extension-dev/component_services/spec-file/property_types/tags.md) to give them a bit more configuration how they are used in developer or at runtime

The [ServoyApi (serverside)](/reference/extension-dev/component_services/servoyapi.md) and [Console](/reference/extension-dev/component_services/console.md) api objects are exposed in server size scripts that components can have.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/extension-dev/component_services.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
